package com.benyun.core.init;

import com.benyun.core.dao.AddrCategoryDao;
import com.benyun.core.dao.TypeByDao;
import com.benyun.core.entity.AddrCategory;
import com.benyun.core.entity.ManageType;
import com.benyun.core.entity.TypeBy;
import com.benyun.core.service.ManageTypeService;
import com.benyun.core.utils.HashUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

import java.util.HashMap;

@Configuration
public class BenyunCoreInit {
    @Autowired
    AddrCategoryDao addrCategoryDao;

    @Autowired
    ManageTypeService manageTypeService;

    @Autowired
    TypeByDao byDao;

    @Bean("cityTierMap")
    public HashMap getCityTierMap(){
        HashMap<String, String> hashMap = new HashMap<>();
        for (AddrCategory addrCategory : addrCategoryDao.selectList(null)) {
            if(addrCategory.getCityTier() != null && !addrCategory.getCityTier().equals("")){
                if(addrCategory.getDistrict()!=null && !addrCategory.getDistrict().equals("")){
                    hashMap.put(addrCategory.getAddrCode(), addrCategory.getCityTier());
                }else if(addrCategory.getCity()!=null && !addrCategory.getCity().equals("")){
                    hashMap.put(addrCategory.getAddrCode().substring(0,4), addrCategory.getCityTier());
                }else
                    hashMap.put(addrCategory.getAddrCode().substring(0,2), addrCategory.getCityTier());
            }
        }
        return hashMap;
    }

    @Bean("ManageType")
    public HashMap getManageType(){
        HashMap<String,String> hashMap = new HashMap<>();
        for (ManageType datum : manageTypeService.getData()) {
            if(!datum.getMidCategory().equals(""))
                hashMap.put(datum.getMidCategory(),datum.getManageTypeCode());
        }
        return hashMap;
    }

    @Bean("addrCodeMap")
    public HashMap getAddrCodeMap(){
        HashMap<String,String> hashMap = new HashMap<>();
        for (AddrCategory addrCode : addrCategoryDao.selectList(null)) {
            hashMap.put(addrCode.getAddrCode(),addrCode.getAddrInfo());
        }
        return hashMap;
    }

    @Bean("typeByMap")
    public HashMap getTypeByMap(){
        HashMap<String,String> hashMap = new HashMap<>();
        for (TypeBy datum : byDao.selectList(null)) {
            hashMap.put(datum.getTypeCodeBy(),datum.getFullInfo());
        }
        return hashMap;
    }
}
